#ifndef __ARRAY_H__
#define __ARRAY_H__

#include "paging.h"

typedef struct {
	int size;
	int capacity;
	PageInfo *buffer;
}Array;

NTSTATUS array_init(Array *arr);
NTSTATUS array_free(Array *arr);
NTSTATUS array_insert_back(Array *arr, PageInfo *page);
PageInfo *array_get_by_index(Array *arr, int index);
void array_sort(Array *arr);
PageInfo *array_search(Array *arr, DWORD addr);

#define array_size(arr) arr->size

#endif