#include <ntddk.h>
#include "idt.h"

/* Hook Interrupt Handler, it get interrupt number and 
 *
 *
 *
 */
VOID HookInt(UCHAR interrupt, PVOID NewHandler, PVOID OldHandler)
{
	PIDTENTRY MyIdtEntry;
	ULONG pInt;
	IDTR Idtr;
	
	__asm{
		cli
		sidt Idtr
	}

	if(interrupt*sizeof(IDTENTRY)<Idtr.Limit)
	{
		MyIdtEntry=(PIDTENTRY)Idtr.Base;

		*(PULONG)OldHandler=(MyIdtEntry[interrupt].OffsetHigh<<16)|MyIdtEntry[interrupt].OffsetLow;

		pInt=(ULONG)&MyIdtEntry[interrupt];

		MyIdtEntry[interrupt].OffsetLow=(USHORT)NewHandler;
		MyIdtEntry[interrupt].OffsetHigh=(USHORT)((ULONG)NewHandler>>16);

		__asm invlpg pInt
	}

	__asm sti
}

VOID UnHookInt(UCHAR interrupt, PVOID OldHandler)
{
	PIDTENTRY MyIdtEntry;
	ULONG pInt;
	IDTR Idtr;

	__asm{
		cli
		sidt Idtr
	}

	if(interrupt*sizeof(IDTENTRY)<Idtr.Limit)
	{
		MyIdtEntry=(PIDTENTRY)Idtr.Base;

		pInt=(ULONG)&MyIdtEntry[interrupt];

		MyIdtEntry[interrupt].OffsetLow=(USHORT)OldHandler;
		MyIdtEntry[interrupt].OffsetHigh =(USHORT)((ULONG)OldHandler>>16);

		_asm invlpg pInt
	}

	__asm sti
}

