#ifndef __LOGGER_H__
#define __LOGGER_H__

#include <ntddk.h>


typedef struct {
	ULONG CS;
	ULONG EIP;
	ULONG FaultAddress;
	ULONG ErrorCode;
}LogData;

typedef struct {
	int length;
	int head;
	int tail;
	LogData *queue;
}LogsQueue;

typedef struct {
	LogsQueue *Logs;
	int nCore;
}MultiLogger;

NTSTATUS logger_init(ULONG max);
NTSTATUS logger_start();
void logger_stop(void);
void logger_destroy();
int logger_enqueue(int Cpu, ULONG cs, ULONG eip, ULONG fault_address, ULONG error_code);
int logger_dequeue(int Cpu, LogData *log);



#endif