#include "paging.h"

/* Get pte pointer from page table, 
 * PTE table contain attribute of page
 *
 * Arguments:
 *  Virtual Address of usemode process
 *
 * Return:
 *  Pointer to PTE_ST
 */
pPTE_ST GetPte(ULONG va)
{

	pPTE_ST pte;
	

	
	/* check whether PAE flag is set or not */
	if (!IsPAEEnable()){
		pte = (pPTE_ST)MiGetPteAddress(va);
	}
	
	return pte;
}

/* Check whether PAE enable in current system
 *
 * Arguments:
 *  None
 *
 * Return:
 *  if enable return 1, otherwise 0
 */
int IsPAEEnable(void)
{
	ULONG Cr4;
		
	/* to check PAE we need get cr4 register and check bit 5 */
	__asm {
		/* mov eax, cr4 */
		_emit 0x0F
		_emit 0x20
		_emit 0xE0
		
		mov Cr4, eax
	}
	
	if ((Cr4 & 32) == 32){
		return 1;
	}
	
	return 0;
}
