#ifndef _PAGING_H_
#define _PAGING_H_

#include <ntddk.h>
#include "types.h"

/* page table structure
 */
typedef struct _sPTE {
    /* 00 */ ULONG Valid : 1;
    /* 01 */ ULONG Writable : 1;        // changed for MP version
    /* 02 */ ULONG Owner : 1;
    /* 03 */ ULONG WriteThrough : 1;
    /* 04 */ ULONG CacheDisable : 1;
    /* 05 */ ULONG Accessed : 1;
    /* 06 */ ULONG Dirty : 1;
    /* 07 */ ULONG LargePage : 1;
    /* 08 */ ULONG Global : 1;
    /* 09 */ ULONG CopyOnWrite : 1; // software field
    /* 0A */ ULONG Prototype : 1;   // software field
    /* 0B */ ULONG Write : 1;       // software field - MP change
    /* 0C */ ULONG PageFrameNumber : 20;
} PTE_ST, *pPTE_ST;
extern char _sPTE_VALIDATOR [5-(int)sizeof(PTE_ST)]; // sizeof PTE_ST should be <= 4 bytes!!! This is to make sure
extern char _sPTE_VALIDATOR2[(int)sizeof(PTE_ST)-3]; // it will stay the correct size

#define PTE_BASE 0xC0000000
#define MiGetPteAddress(va)		(((((ULONG)(va)) >> 12) << 2) + PTE_BASE)
#define MiGetPtePaeAddress(va)	(((((ULONG)(va)) >> 12) << 3) + PTE_BASE)

pPTE_ST GetPte(ULONG va);
int IsPAEEnable(void);

// structure to store a page attribute and other info gain from ZwQueryVirtualMemory
typedef struct {
	DWORD dwBaseAddress;
	DWORD dwBaseAllocated;
	DWORD dwPteAddress;
}PageInfo;

#endif 